#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

namespace UndoRedoSample
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;
	using Syncfusion.Windows.Forms.Grid;
	using Syncfusion.ComponentModel;

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region members
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem EditUndo;
		private System.Windows.Forms.MenuItem EditRedo;
		private System.Windows.Forms.MenuItem EditClear;
		private System.Windows.Forms.MenuItem EditTransactions;
		private System.Windows.Forms.MenuItem EditClearUndo;
		private System.Windows.Forms.MenuItem EditClearRedo;
		private System.Windows.Forms.MenuItem EditTransactionsBegin;
		private System.Windows.Forms.MenuItem EditTransactionsCommit;
		private System.Windows.Forms.MenuItem EditTransactionsRollBack;
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.ListBox listBox2;

		//needed to conditionally display new stacks
		private int oldRedoCount;
		private int oldUndoCount;
		private System.Windows.Forms.MenuItem editMenu;

		#endregion
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton toolBarUndo;
		private System.Windows.Forms.ToolBarButton toolBarRedo;
		private System.Windows.Forms.ToolBarButton toolSeparator;
		private System.Windows.Forms.ToolBarButton toolBeginTrans;
		private System.Windows.Forms.ToolBarButton toolCommitTrans;
		private System.Windows.Forms.ToolBarButton toolRollBack;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			
            //System.Drawing.Icon ico = new System.Drawing.Icon(GetIconFile(@"common\Images\Grid\Icon\sfgrid.ico"));
            //this.Icon = ico ;
			this.gridControl1.DefaultRowHeight = 18;
			this.gridControl1.DefaultColWidth = 70;
            this.gridControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2007Blue;
            this.gridControl1.Properties.GridLineColor = Color.FromArgb(208, 215, 229);
            this.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid;
            GridStyleInfo style = this.gridControl1.BaseStylesMap["Header"].StyleInfo;
            style.TextColor = System.Drawing.Color.MidnightBlue;
            style.Font.Facename = "Verdana";
            style = this.gridControl1.BaseStylesMap["Standard"].StyleInfo;
            style.TextColor = System.Drawing.Color.MidnightBlue;
            style.Font.Facename = "Verdana";
            this.BackColor = Color.FromArgb(223, 227, 239);
			

			//Populate the Grid

			//turn off undo buffer so initial population cannot be undone
			this.gridControl1.CommandStack.Enabled = false;

			//call a routine to populate the grid somehow...
			PopulateMyGrid();
			//turn undo buffer back on...
			this.gridControl1.CommandStack.Enabled = true;

			//handle adding list changes -- handler allows the updating of the display
			this.gridControl1.Invalidated += new InvalidateEventHandler(UpdateListBoxes);

			oldRedoCount = 0;
			oldUndoCount = 0;

			this.gridControl1.RowHeights[0]=0;
			this.gridControl1.ColWidths[0]=0;

			this.gridControl1.TableStyle.BackColor = System.Drawing.Color.FromArgb(218,230,246);
            this.BackColor = Color.FromArgb(223, 227, 239);
//			this.gridControl1.ActivateCurrentCellBehavior=GridCellActivateAction.ClickOnCell;
//			this.gridControl1.ShowCurrentCellBorderBehavior=GridShowCurrentCellBorder.WhenGridActive;

            this.gridControl1.CellsChanging += new GridCellsChangingEventHandler(gridControl1_CellsChanging);
		}

        void gridControl1_CellsChanging(object sender, GridCellsChangingEventArgs e)
        {
            GridRangeInfo range = e.Range;
            if (range.Left == 2 )
                this.gridControl1.CommandStack.Enabled = false;
            else
                this.gridControl1.CommandStack.Enabled = true;
        }

		private string GetIconFile(string bitmapName)
        {
            for (int n = 0; n < 10; n++)
            {
                if (System.IO.File.Exists(bitmapName))
                    return bitmapName;

                bitmapName = @"..\" + bitmapName;
            }

            return bitmapName;
        }

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle1 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle2 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle3 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle4 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridCellInfo gridCellInfo1 = new Syncfusion.Windows.Forms.Grid.GridCellInfo();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.editMenu = new System.Windows.Forms.MenuItem();
            this.EditUndo = new System.Windows.Forms.MenuItem();
            this.EditRedo = new System.Windows.Forms.MenuItem();
            this.EditClear = new System.Windows.Forms.MenuItem();
            this.EditClearUndo = new System.Windows.Forms.MenuItem();
            this.EditClearRedo = new System.Windows.Forms.MenuItem();
            this.EditTransactions = new System.Windows.Forms.MenuItem();
            this.EditTransactionsBegin = new System.Windows.Forms.MenuItem();
            this.EditTransactionsCommit = new System.Windows.Forms.MenuItem();
            this.EditTransactionsRollBack = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuHelp = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.listBox1 = new System.Windows.Forms.ListBox();
            this.listBox2 = new System.Windows.Forms.ListBox();
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this.toolBarUndo = new System.Windows.Forms.ToolBarButton();
            this.toolBarRedo = new System.Windows.Forms.ToolBarButton();
            this.toolSeparator = new System.Windows.Forms.ToolBarButton();
            this.toolBeginTrans = new System.Windows.Forms.ToolBarButton();
            this.toolCommitTrans = new System.Windows.Forms.ToolBarButton();
            this.toolRollBack = new System.Windows.Forms.ToolBarButton();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.panel1 = new System.Windows.Forms.Panel();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.AllowDragSelectedCols = true;
            this.gridControl1.AllowDragSelectedRows = true;
            this.gridControl1.AllowDrop = true;
            this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            gridBaseStyle1.Name = "Row Header";
            gridBaseStyle1.StyleInfo.BaseStyle = "Header";
            gridBaseStyle1.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Left;
            gridBaseStyle1.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.White);
            gridBaseStyle2.Name = "Column Header";
            gridBaseStyle2.StyleInfo.BaseStyle = "Header";
            gridBaseStyle2.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Center;
            gridBaseStyle3.Name = "Standard";
            gridBaseStyle3.StyleInfo.AllowEnter = false;
            gridBaseStyle3.StyleInfo.AutoSize = false;
            gridBaseStyle3.StyleInfo.BaseStyle = "";
            gridBaseStyle3.StyleInfo.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame);
            gridBaseStyle3.StyleInfo.Borders.Left = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame);
            gridBaseStyle3.StyleInfo.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame);
            gridBaseStyle3.StyleInfo.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Standard, System.Drawing.SystemColors.WindowFrame);
            gridBaseStyle3.StyleInfo.CellAppearance = Syncfusion.Windows.Forms.Grid.GridCellAppearance.Flat;
            gridBaseStyle3.StyleInfo.CellType = "TextBox";
            gridBaseStyle3.StyleInfo.CellValueType = null;
            gridBaseStyle3.StyleInfo.Clickable = true;
            gridBaseStyle3.StyleInfo.CultureInfo = null;
            gridBaseStyle3.StyleInfo.Description = "";
            gridBaseStyle3.StyleInfo.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Editable;
            gridBaseStyle3.StyleInfo.Enabled = true;
            gridBaseStyle3.StyleInfo.FloatCell = true;
            gridBaseStyle3.StyleInfo.FloodCell = true;
            gridBaseStyle3.StyleInfo.Font.Bold = false;
            gridBaseStyle3.StyleInfo.Font.Facename = "Verdana";
            gridBaseStyle3.StyleInfo.Font.Italic = false;
            gridBaseStyle3.StyleInfo.Font.Size = 8.25F;
            gridBaseStyle3.StyleInfo.Font.Strikeout = false;
            gridBaseStyle3.StyleInfo.Font.Underline = false;
            gridBaseStyle3.StyleInfo.Format = "";
            gridBaseStyle3.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Left;
            gridBaseStyle3.StyleInfo.HotkeyPrefix = System.Drawing.Text.HotkeyPrefix.Show;
            gridBaseStyle3.StyleInfo.ImageList = null;
            gridBaseStyle3.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.Window);
            gridBaseStyle3.StyleInfo.MaxLength = 0;
            gridBaseStyle3.StyleInfo.ReadOnly = false;
            gridBaseStyle3.StyleInfo.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
            gridBaseStyle3.StyleInfo.Text = "";
            gridBaseStyle3.StyleInfo.TextAlign = Syncfusion.Windows.Forms.Grid.GridTextAlign.Default;
            gridBaseStyle3.StyleInfo.TextColor = System.Drawing.Color.MidnightBlue;
            gridBaseStyle3.StyleInfo.TextMargins.Bottom = 1;
            gridBaseStyle3.StyleInfo.TextMargins.Left = 1;
            gridBaseStyle3.StyleInfo.TextMargins.Right = 1;
            gridBaseStyle3.StyleInfo.TextMargins.Top = 1;
            gridBaseStyle3.StyleInfo.Trimming = System.Drawing.StringTrimming.Character;
            gridBaseStyle3.StyleInfo.TriState = false;
            gridBaseStyle3.StyleInfo.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Top;
            gridBaseStyle3.StyleInfo.VerticalScrollbar = false;
            gridBaseStyle3.StyleInfo.WrapText = true;
            gridBaseStyle4.Name = "Header";
            gridBaseStyle4.StyleInfo.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.Borders.Left = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.CellType = "Header";
            gridBaseStyle4.StyleInfo.Font.Bold = true;
            gridBaseStyle4.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(199)))), ((int)(((byte)(184))))), System.Drawing.Color.FromArgb(((int)(((byte)(238)))), ((int)(((byte)(234)))), ((int)(((byte)(216))))));
            gridBaseStyle4.StyleInfo.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Middle;
            this.gridControl1.BaseStylesMap.AddRange(new Syncfusion.Windows.Forms.Grid.GridBaseStyle[] {
            gridBaseStyle1,
            gridBaseStyle2,
            gridBaseStyle3,
            gridBaseStyle4});
            this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.gridControl1.DefaultColWidth = 70;
            this.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid;
            this.gridControl1.DefaultRowHeight = 18;
            this.gridControl1.DragSelectedCellsMouseButtonsMask = System.Windows.Forms.MouseButtons.None;
            gridCellInfo1.Col = -1;
            gridCellInfo1.Row = -1;
            this.gridControl1.GridCells.AddRange(new Syncfusion.Windows.Forms.Grid.GridCellInfo[] {
            gridCellInfo1});
            this.gridControl1.Location = new System.Drawing.Point(256, 40);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.RowCount = 30;
            this.gridControl1.Size = new System.Drawing.Size(360, 368);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.editMenu,
            this.menuItem1});
            // 
            // editMenu
            // 
            this.editMenu.Index = 0;
            this.editMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.EditUndo,
            this.EditRedo,
            this.EditClear,
            this.EditTransactions});
            this.editMenu.Text = "Edit";
            this.editMenu.Popup += new System.EventHandler(this.editMenu_Popup);
            // 
            // EditUndo
            // 
            this.EditUndo.Index = 0;
            this.EditUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
            this.EditUndo.Text = "Undo";
            this.EditUndo.Click += new System.EventHandler(this.EditUndo_Click);
            // 
            // EditRedo
            // 
            this.EditRedo.Index = 1;
            this.EditRedo.Shortcut = System.Windows.Forms.Shortcut.CtrlY;
            this.EditRedo.Text = "Redo";
            this.EditRedo.Click += new System.EventHandler(this.EditRedo_Click);
            // 
            // EditClear
            // 
            this.EditClear.Index = 2;
            this.EditClear.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.EditClearUndo,
            this.EditClearRedo});
            this.EditClear.Text = "Clear";
            // 
            // EditClearUndo
            // 
            this.EditClearUndo.Index = 0;
            this.EditClearUndo.Text = "Undo";
            this.EditClearUndo.Click += new System.EventHandler(this.EditClearUndo_Click);
            // 
            // EditClearRedo
            // 
            this.EditClearRedo.Index = 1;
            this.EditClearRedo.Text = "Redo";
            this.EditClearRedo.Click += new System.EventHandler(this.EditClearRedo_Click);
            // 
            // EditTransactions
            // 
            this.EditTransactions.Index = 3;
            this.EditTransactions.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.EditTransactionsBegin,
            this.EditTransactionsCommit,
            this.EditTransactionsRollBack});
            this.EditTransactions.Text = "Transactions";
            // 
            // EditTransactionsBegin
            // 
            this.EditTransactionsBegin.Index = 0;
            this.EditTransactionsBegin.Text = "Begin";
            this.EditTransactionsBegin.Click += new System.EventHandler(this.EditTransactionsBegin_Click);
            // 
            // EditTransactionsCommit
            // 
            this.EditTransactionsCommit.Index = 1;
            this.EditTransactionsCommit.Text = "Commit";
            this.EditTransactionsCommit.Click += new System.EventHandler(this.EditTransactionsCommit_Click);
            // 
            // EditTransactionsRollBack
            // 
            this.EditTransactionsRollBack.Index = 2;
            this.EditTransactionsRollBack.Text = "RollBack";
            this.EditTransactionsRollBack.Click += new System.EventHandler(this.EditTransactionsRollBack_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 1;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuHelp,
            this.menuItem2});
            this.menuItem1.Text = "Help";
            // 
            // menuHelp
            // 
            this.menuHelp.Index = 0;
            this.menuHelp.Text = "Help";
            this.menuHelp.Click += new System.EventHandler(this.menuHelp_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 1;
            this.menuItem2.Text = "About";
            this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
            // 
            // listBox1
            // 
            this.listBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.listBox1.Location = new System.Drawing.Point(16, 40);
            this.listBox1.Name = "listBox1";
            this.listBox1.Size = new System.Drawing.Size(224, 158);
            this.listBox1.TabIndex = 1;
            // 
            // listBox2
            // 
            this.listBox2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.listBox2.Location = new System.Drawing.Point(16, 208);
            this.listBox2.Name = "listBox2";
            this.listBox2.Size = new System.Drawing.Size(224, 171);
            this.listBox2.TabIndex = 2;
            // 
            // toolBar1
            // 
            this.toolBar1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.toolBarUndo,
            this.toolBarRedo,
            this.toolSeparator,
            this.toolBeginTrans,
            this.toolCommitTrans,
            this.toolRollBack});
            this.toolBar1.DropDownArrows = true;
            this.toolBar1.ImageList = this.imageList1;
            this.toolBar1.Location = new System.Drawing.Point(0, 0);
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ShowToolTips = true;
            this.toolBar1.Size = new System.Drawing.Size(616, 29);
            this.toolBar1.TabIndex = 3;
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
            // 
            // toolBarUndo
            // 
            this.toolBarUndo.ImageIndex = 0;
            this.toolBarUndo.Name = "toolBarUndo";
            this.toolBarUndo.ToolTipText = "Undo the last action";
            // 
            // toolBarRedo
            // 
            this.toolBarRedo.ImageIndex = 1;
            this.toolBarRedo.Name = "toolBarRedo";
            this.toolBarRedo.ToolTipText = "Redo the last action undone";
            // 
            // toolSeparator
            // 
            this.toolSeparator.Name = "toolSeparator";
            this.toolSeparator.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // toolBeginTrans
            // 
            this.toolBeginTrans.ImageIndex = 2;
            this.toolBeginTrans.Name = "toolBeginTrans";
            this.toolBeginTrans.ToolTipText = "Begin a transaction";
            // 
            // toolCommitTrans
            // 
            this.toolCommitTrans.ImageIndex = 3;
            this.toolCommitTrans.Name = "toolCommitTrans";
            this.toolCommitTrans.ToolTipText = "Commit the transaction";
            // 
            // toolRollBack
            // 
            this.toolRollBack.ImageIndex = 4;
            this.toolRollBack.Name = "toolRollBack";
            this.toolRollBack.ToolTipText = "RollBack a transaction";
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add(this.gridControl1);
            this.panel1.Controls.Add(this.listBox2);
            this.panel1.Controls.Add(this.listBox1);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(616, 393);
            this.panel1.TabIndex = 4;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(616, 393);
            this.Controls.Add(this.toolBar1);
            this.Controls.Add(this.panel1);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Undo-Redo Demo";
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		[STAThread]
		public static void Main() 
		{
# if SyncfusionFramework1_1 || SyncfusionFramework2_0  
			Application.EnableVisualStyles();
# endif		
			Application.Run(new Form1());
		}


		#region Populate the grid
		private void PopulateMyGrid()
		{
			//			//used to time things if desired
			//			int startTime = Environment.TickCount;

			//populate with random numbers
			//just place values directly into style, slow but straight-forward
			Random r = new Random();
			for(int i = 1; i <= this.gridControl1.RowCount; ++i)
				for(int j = 1; j <= this.gridControl1.ColCount; ++j)
					this.gridControl1[i,j].CellValue = r.Next(1000);

			//			//for more efficient population, could use a call to PopulateValues
			//			//for example, this code is more than a factor of ten quicker...
			//			Random r = new Random();
			//			int[,] table = new int[this.gridControl1.RowCount, this.gridControl1.ColCount];
			//			for(int i = 1; i <= this.gridControl1.RowCount; ++i)
			//				for(int j = 1; j <= this.gridControl1.ColCount; ++j)
			//					table[i-1, j-1] = r.Next(1000);
			//
			//			this.gridControl1.PopulateValues(
			//							GridRangeInfo.Cells(1, 1, this.gridControl1.RowCount, this.gridControl1.ColCount),
			//							table); 
		
			//			MessageBox.Show((Environment.TickCount - startTime).ToString() + " ticks");
	

		}

		#endregion

		#region Menu Handlers
		private void EditUndo_Click(object sender, System.EventArgs e)
		{
			if (!this.gridControl1.CommandStack.InTransaction)
			{
				this.gridControl1.CommandStack.Undo();
				ShowStacks();
			}
		}

		private void EditRedo_Click(object sender, System.EventArgs e)
		{
			if (!this.gridControl1.CommandStack.InTransaction)
			{
				this.gridControl1.CommandStack.Redo();
				ShowStacks();
			}
		}

		private void EditClearUndo_Click(object sender, System.EventArgs e)
		{
			if (!this.gridControl1.CommandStack.InTransaction)
			{
				this.gridControl1.CommandStack.UndoStack.Clear();
				ShowStacks();
			}
		}

		private void EditClearRedo_Click(object sender, System.EventArgs e)
		{
			this.gridControl1.CommandStack.RedoStack.Clear();
			ShowStacks();
		}

		private void EditTransactionsBegin_Click(object sender, System.EventArgs e)
		{
			this.gridControl1.CommandStack.BeginTrans("Transaction beginning-");
			ShowStacks();
			this.toolBeginTrans.ImageIndex = 5;
		}

		private void EditTransactionsCommit_Click(object sender, System.EventArgs e)
		{
			if(this.gridControl1.CommandStack.InTransaction)
			{
				this.gridControl1.CommandStack.CommitTrans();
				this.toolBeginTrans.ImageIndex = 2;
				ShowStacks();
			}
		}

		private void EditTransactionsRollBack_Click(object sender, System.EventArgs e)
		{
			if(this.gridControl1.CommandStack.InTransaction)
			{
				this.gridControl1.CommandStack.Rollback();
				this.toolBeginTrans.ImageIndex = 2;
				ShowStacks();
			}
		}
		#endregion

		#region Updates to the display lists

		private void UpdateListBoxes(object sender, InvalidateEventArgs e)
		{
			ShowStacks();
		}

		private void ShowStacks()
		{
			ShowRedoStack();
			ShowUndoStack();
		}

		private void ShowUndoStack()
		{
			int numUndos = this.gridControl1.CommandStack.UndoStack.Count;
			if(numUndos != this.oldUndoCount || this.gridControl1.CommandStack.InTransaction)
			{
				this.listBox1.Items.Clear();
				this.listBox1.Items.Add(string.Format("{0} Undo items", numUndos));
	
				if(numUndos > 0 || this.gridControl1.CommandStack.IsRecording)
					DisplayCommandsInStack(this.gridControl1.CommandStack.UndoStack.ToArray(), "", listBox1, true);
				this.oldUndoCount = numUndos;
			}

		}

		private void ShowRedoStack()
		{
			int numRedos = this.gridControl1.CommandStack.RedoStack.Count;
			if(numRedos != this.oldRedoCount || this.gridControl1.CommandStack.InTransaction)
			{
				this.listBox2.Items.Clear();
				this.listBox2.Items.Add(string.Format("{0} Redo items", numRedos));
				if(numRedos > 0 || this.gridControl1.CommandStack.IsRecording)
					DisplayCommandsInStack(this.gridControl1.CommandStack.RedoStack.ToArray(), "", listBox2, false);
				this.oldRedoCount = numRedos;
			}
		}

		
		private void DisplayCommandsInStack(object[] items, string indent, ListBox _listbox, bool includeCurrentCommand)
		{
			string s;
			SyncfusionCommand c;
			GridTransactionCommand tc;
			int cutOff;

			//handle the case where we are recording a transaction
			if (includeCurrentCommand && this.gridControl1.CommandStack.InTransaction)
			{
				try
				{
					tc = this.gridControl1.CommandStack.CurrentTransactionCommand;
					DisplayCommandsInStack(tc.Stack.ToArray(), "    > ", _listbox, false);
				}
				catch{}
			}

			foreach(object o in items)
			{
				try
				{
					c = (SyncfusionCommand) o;
					if(c != null && c.Description != null)
						s = c.Description;
					else
						s = o.ToString();
					cutOff =  1 + Math.Max(s.LastIndexOf("+"), s.LastIndexOf("."));
					_listbox.Items.Add(indent + s.Substring(cutOff));
				}
				catch{}

				//check if is a transaction command
				try
				{
					tc = o as GridTransactionCommand;
					if(tc != null)
					{
						DisplayCommandsInStack(tc.Stack.ToArray(), "    > ", _listbox, false);
					}
				}
				catch{}

			}

			
		}

		#endregion

		private void editMenu_Popup(object sender, System.EventArgs e)
		{
			EditUndo.Enabled = this.gridControl1.CommandStack.UndoStack.Count > 0;
			EditRedo.Enabled = this.gridControl1.CommandStack.RedoStack.Count > 0;
		
			EditClear.Enabled = EditUndo.Enabled || EditRedo.Enabled;
			EditClearUndo.Enabled = EditUndo.Enabled;
			EditClearRedo.Enabled = EditRedo.Enabled;
		
			EditTransactionsCommit.Enabled = this.gridControl1.CommandStack.InTransaction;
			EditTransactionsRollBack.Enabled = this.gridControl1.CommandStack.InTransaction;
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch(e.Button.ImageIndex)
			{
				case 0://toolBarUndo:
					EditUndo_Click(this, EventArgs.Empty);
					break;
				case 1://toolBarRedo:
					EditRedo_Click(this, EventArgs.Empty);
					break;
				case 2://toolBeginTrans:
					EditTransactionsBegin_Click(this, EventArgs.Empty);
					break;
				case 3://toolCommitTrans:
					EditTransactionsCommit_Click(this, EventArgs.Empty);
					break;
				case 4://toolRollBack:
					EditTransactionsRollBack_Click(this, EventArgs.Empty);
					break;
				default:
					break;
			}
		}

		private void menuHelp_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("Change some cells, or move columns or rows in the\r\ngrid. You will see the Undo list start to grow. \r\n\r\nClick the Undo button or use the menu to undo an action.\r\n You will see the Redo list change.\r\n\r\nUse the Begin Transaction to start a group of changes that\r\nare treated as a single Undo/Redo command. Use Commit \r\nTransaction to signal the end of a transaction group.");
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
            DemoCommon.AboutForm abtForm = new DemoCommon.AboutForm(AppDomain.CurrentDomain.GetAssemblies());
            abtForm.ShowDialog();
		}
	}
}
